package com.chinaitop.depot.device.controller;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.device.model.StorageDeviceinput;
import com.chinaitop.depot.device.service.StorageDeviceInputService;
import com.fasterxml.jackson.databind.ObjectMapper;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping(value= {"/deviceOut"})
@Api(value= "StorageDeviceOutController", description = "器材设备报废")
public class StorageDeviceOutController {

	@Resource
	private StorageDeviceInputService deviceInputService;
	
    
    /**
     * 报废
     */
    @RequestMapping(value="/Out", produces = MediaType.APPLICATION_JSON_VALUE, method=RequestMethod.POST)
	@ApiOperation(value="报废", notes = "报废")
    public Map<String, Object> out(String deviceListJson) {
        Map<String, Object> modelMap = new HashMap<>();
        // JSON字符串转对象
        ObjectMapper mapper = new ObjectMapper();
        StorageDeviceinput storageDeviceinput = null;
        try {
        	storageDeviceinput = (StorageDeviceinput)mapper.readValue(deviceListJson, StorageDeviceinput.class);
        	storageDeviceinput.setStatus(1);
        	deviceInputService.updateByPrimaryKeySelective(storageDeviceinput);
            modelMap.put("status", "success");
        } catch (IOException e) {
            modelMap.put("status", "error");
            e.printStackTrace();
        }
        return modelMap;
    }
    
   /**
     * 批量结束报废
     */
    @RequestMapping(value="/outMore", produces = MediaType.APPLICATION_JSON_VALUE, method=RequestMethod.POST)
   	@ApiOperation(value="批量报废", notes = "批量报废")
    public Map<String, Object> endMore(String deviceListJson) {
        Map<String, Object> modelMap = new HashMap<>();
        // JSON字符串转对象
        ObjectMapper mapper = new ObjectMapper();
        try {
        	JSONObject jsonObject = JSONObject.parseObject(deviceListJson);
        	String idStr = jsonObject.getString("id");
        	
        	if(idStr != null && !"".equals(idStr)){
        		String[] ids = idStr.split(",");
        		for(int i=0; i<ids.length; i++){
        			StorageDeviceinput storageDeviceinput = new StorageDeviceinput();
        			storageDeviceinput.setStatus(0);
        			storageDeviceinput.setId(Integer.parseInt(ids[i]));
        			deviceInputService.updateByPrimaryKeySelective(storageDeviceinput);
        		}
        	}
            modelMap.put("status", "success");
        } catch (Exception e) {
            modelMap.put("status", "error");
            e.printStackTrace();
        }
        return modelMap;
    }

}
