package com.chinaitop.depot.device.service.impl;

import java.util.Date;
import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.chinaitop.depot.device.mapper.BasicEquipmentEquipmentPoolMapper;
import com.chinaitop.depot.device.model.BasicEquipmentEquipmentPool;
import com.chinaitop.depot.device.model.BasicEquipmentEquipmentPoolExample;
import com.chinaitop.depot.device.service.BasicEquipmentEquipmentPoolService;

@Service
public class BasicEquipmentEquipmentPoolServiceImpl implements BasicEquipmentEquipmentPoolService {

	@Resource
	private BasicEquipmentEquipmentPoolMapper mapper;

	@Override
	public void add(BasicEquipmentEquipmentPool record) {
		mapper.insert(record);
	}

	@Override
	public void update(BasicEquipmentEquipmentPool record) {
		mapper.updateByPrimaryKeySelective(record);
	}

	@Override
	public void remove(Integer id) {
		mapper.deleteByPrimaryKey(id);
	}

	@Override
	public BasicEquipmentEquipmentPool findByIdObj(Integer id) {
		return mapper.selectByPrimaryKey(id);
	}

	@Override
	public List<BasicEquipmentEquipmentPool> findByCondition(BasicEquipmentEquipmentPoolExample example) {
		return mapper.selectByExample(example);
	}

	@Override
	public String importData(List<List<String>> list, Integer orgId) {
		Date date = new Date();
		String msg = "";
    	int len = 0;
		BasicEquipmentEquipmentPool pool = null;
        
        for (int i = 0; i < list.size(); i++) {
            List<String> revList = list.get(i);
            
            for (int j = 0; j < revList.size(); j++) {
            	switch(j) {
            		case 0:
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				len = revList.get(j).length();
                    		if (len > 50) {
                    			msg = "第 "+(i+1)+" 行第 1 列的值的长度不能超过50！";
                    			return msg;
                    		}
            				pool = new BasicEquipmentEquipmentPool();
            				pool.setPutPosition(revList.get(j));
            				pool.setOrgId(orgId);
            			}
                		break;
            		case 1:
            			if (pool != null) {
            				len = revList.get(j).length();
                    		if (len > 50) {
                    			msg = "第 "+(i+1)+" 行第 2 列的值的长度不能超过50！";
                    			return msg;
                    		}
            				pool.setShelfId(revList.get(j));
            			}
            			break;
            		case 2:
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				len = revList.get(j).length();
                    		if (len > 50) {
                    			msg = "第 "+(i+1)+" 行第 3 列的值的长度不能超过50！";
                    			return msg;
                    		}
            				if (pool != null) {
	            				pool.setWarehouseId(revList.get(j));
            				}
            			}
            			break;
            		case 3:
            			if (revList.get(j) != null && !"".equals(revList.get(j))) {
            				len = revList.get(j).length();
                    		if (len > 255) {
                    			msg = "第 "+(i+1)+" 行第 4 列的值的长度不能超过255！";
                    			return msg;
                    		}
            				if (pool != null) {
	            				pool.setRemark(revList.get(j));
	            				pool.setOrgId(orgId);
	            				pool.setInputDate(date);
	            				mapper.insertSelective(pool);
            				}
            			}
            			pool = null;
            			break;
            		default :
            			break;
            	}
            }
           
        }
        return msg;
	}

}
