package com.chinaitop.depot.device.service.impl;

import com.chinaitop.depot.device.mapper.DFacilitiesRepairMapper;
import com.chinaitop.depot.device.model.DFacilitiesRepair;
import com.chinaitop.depot.device.model.DFacilitiesRepairExample;
import com.chinaitop.depot.device.service.DFacilitiesRepairService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author yu.ren
 * @description: 1:设备,2:设施,3:器材
 * @create 2022-04-16 11:26
 */
@Service
public class DFacilitiesRepairServiceImpl implements DFacilitiesRepairService {
    @Resource
    private DFacilitiesRepairMapper dFacilitiesRepairMapper;

    @Override
    public List<DFacilitiesRepair> getList(DFacilitiesRepairExample example) {
        return dFacilitiesRepairMapper.selectByExample(example);
    }

    @Override
    public void save(DFacilitiesRepair dFacilitiesRepair) {
        dFacilitiesRepairMapper.insert(dFacilitiesRepair);
    }

    @Override
    public void update(DFacilitiesRepair dFacilitiesRepair) {
        dFacilitiesRepairMapper.updateByPrimaryKey(dFacilitiesRepair);
    }

    @Override
    public void remove(Integer id) {
        dFacilitiesRepairMapper.deleteByPrimaryKey(id);
    }
}
