package com.chinaitop.depot.device.service.impl;

import com.chinaitop.depot.device.mapper.DSbxxsjyMapper;
import com.chinaitop.depot.device.model.DSbxxsjy;
import com.chinaitop.depot.device.model.DSbxxsjyExample;
import com.chinaitop.depot.device.service.DSblxxjyService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author qingsong.han
 * @description:
 * @create 2020-03-20 13:50
 */
@Service
public class DSblxxjyServiceImpl implements DSblxxjyService {
    @Resource
    private DSbxxsjyMapper sbxxsjyMapper;

    @Override
    public List<DSbxxsjy> getList(DSbxxsjyExample example) {
        return sbxxsjyMapper.selectByExample(example);
    }

    @Override
    public void save(DSbxxsjy dSbxxsjy) {
        sbxxsjyMapper.insert(dSbxxsjy);
    }

    @Override
    public void update(DSbxxsjy dSbxxsjy) {
        DSbxxsjyExample example = new DSbxxsjyExample();
        DSbxxsjyExample.Criteria criteria = example.createCriteria();
        criteria.andSbbhEqualTo(dSbxxsjy.getSbbh());
        sbxxsjyMapper.updateByExampleSelective(dSbxxsjy,example);
    }

    @Override
    public void remove(String sbbh, String s) {
        DSbxxsjyExample example = new DSbxxsjyExample();
        DSbxxsjyExample.Criteria criteria = example.createCriteria();
        criteria.andSbbhEqualTo(sbbh);
        criteria.andSzdwdmEqualTo(s);
        sbxxsjyMapper.deleteByExample(example);
    }
}
