package com.chinaitop.depot.device.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.device.mapper.StorageDevicecheckMapper;
import com.chinaitop.depot.device.mapper.StorageDeviceinputMapper;
import com.chinaitop.depot.device.model.*;
import com.chinaitop.depot.device.service.DSblxxjyService;
import com.chinaitop.depot.device.service.StorageDeviceCheckService;
import com.chinaitop.depot.utils.ParameterUtil;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.beans.Transient;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @auther mafy
 * @createtime 2018/1/3 0003
 */
@Service
public class StorageDeviceCheckServiceImpl implements StorageDeviceCheckService {

    @Resource
    private StorageDevicecheckMapper storageDevicecheckMapper;

    @Resource
    private StorageDeviceinputMapper storageDeviceinputMapper;

    @Resource
    private DSblxxjyService sblxxjyService;

    /**
     * 分页查询盘点单
     *
     * @param storageDevicecheckExample
     * @return
     */
    @Override
    public List<StorageDevicecheck> queryByExample(StorageDevicecheckExample storageDevicecheckExample) {
        return storageDevicecheckMapper.selectBySql(storageDevicecheckExample);
    }


    /**
     * 新增的时候查询input表里面的数据
     *
     * @param storageDeviceinputExample
     * @return
     */
    @Override
    public List<StorageDeviceinput> childZlList(StorageDeviceinputExample storageDeviceinputExample) {
        return storageDeviceinputMapper.selectByExample(storageDeviceinputExample);
    }

    /**
     * 根据depotId查询对应数据
     *
     * @param depotId
     * @return
     */
    @Override
    public List<StorageDevicecheck> loadDataByDepotId( String pddh) {
        DSbxxsjyExample example = new DSbxxsjyExample();
        DSbxxsjyExample.Criteria criteria2 = example.createCriteria();
        if (StringUtils.isNotBlank(pddh)) {
            criteria2.andSbbhEqualTo(pddh);
        }
        //获取最新的数量
        DSbxxsjy dSbxxsjy = sblxxjyService.getList(example).get(0);

        StorageDevicecheckExample storageDevicecheckExample = new StorageDevicecheckExample();
        StorageDevicecheckExample.Criteria criteria = storageDevicecheckExample.createCriteria();
        criteria.andCheckNumberEqualTo(pddh);
        List<StorageDevicecheck> storageDevicechecks = storageDevicecheckMapper.selectByExample(storageDevicecheckExample);
        storageDevicechecks.get(0).setStoreCount(dSbxxsjy.getSbsl().intValue());
        return storageDevicechecks;
    }

    /**
     * 获取当天的总盘点记录数
     *
     * @return
     */
    @Override
    public int getCountForDate(Map<String, Object> map) {
        return storageDevicecheckMapper.getCountForDate(map).size();
    }

    /**
     * 按照主键移除
     *
     * @param depotId
     */
    @Override
    public void remove(String checkNumber) {
        StorageDevicecheckExample storageDevicecheckExample = new StorageDevicecheckExample();
        StorageDevicecheckExample.Criteria criteria = storageDevicecheckExample.createCriteria();
        criteria.andCheckNumberEqualTo(checkNumber);
        storageDevicecheckMapper.deleteByExample(storageDevicecheckExample);
    }

    /**
     * 新增
     *
     * @param json
     */
    @Override
    @Transient
    public void add(String json, String type) {
//        JSONArray jsonArray = JSONArray.parseArray(json);
        /*StringBuilder sql = new StringBuilder();
        sql.append("INSERT INTO storage_devicecheck(check_number,check_date,depot_id,check_person,device_type,device_name,model,store_count,really_count,check_result,reason,org_id) VALUES");
       */
        JSONObject jsonObject = JSONObject.parseObject(json);
        StorageDevicecheck deviceCheck = (StorageDevicecheck) JSONObject.toJavaObject(jsonObject, StorageDevicecheck.class);
        remove(deviceCheck.getCheckNumber());
        deviceCheck.setCheckDate(new Date());
        storageDevicecheckMapper.insert(deviceCheck);
    }
}
