package com.chinaitop.depot.device.service.impl;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.chinaitop.depot.device.mapper.StorageDeviceinputMapper;
import com.chinaitop.depot.device.model.ContentBean;
import com.chinaitop.depot.device.model.HouseNameBean;
import com.chinaitop.depot.device.model.HouseTypeBean;
import com.chinaitop.depot.device.model.ShelfContentBean;
import com.chinaitop.depot.device.model.StorageDeviceinput;
import com.chinaitop.depot.device.model.StorageDeviceinputExample;
import com.chinaitop.depot.device.service.StorageDeviceInputService;


@Service
public class StorageDeviceInputServiceImpl implements StorageDeviceInputService{

	@Resource
	private StorageDeviceinputMapper deviceInputMapper;
	
	/**
	 * 分页获取器材信息
	 */
	@Override
	public List<StorageDeviceinput> queryByDevice(StorageDeviceinputExample storageDeviceinputExample) {
		// TODO Auto-generated method stub
	        return deviceInputMapper.selectByExample(storageDeviceinputExample);
	}

	/**
	 * 根据id删除数据
	 */
	@Override
	public void remove(Integer id) {
		// TODO Auto-generated method stub
		deviceInputMapper.deleteByPrimaryKey(id);
	}

	/**
	 * 提交修改和新增
	 */
	@Override
	public void save(StorageDeviceinput storageDeviceinput) {
		// TODO Auto-generated method stub
		if (storageDeviceinput.getId() == null) {
			deviceInputMapper.insert(storageDeviceinput);// 新增数据
		} else {
			deviceInputMapper.updateByPrimaryKeySelective(storageDeviceinput);// 修改数据
		}
	}

	/**
	 * 根据id查询数据
	 */
	@Override
	public StorageDeviceinput loadDataById(int id) {
		// TODO Auto-generated method stub
		return deviceInputMapper.selectByPrimaryKey(id);
	}

	 /**
     * 获取入库的仓房名
     */
	@Override
	public List<HouseNameBean> getHouseList() {
		// TODO Auto-generated method stub
		
		return deviceInputMapper.getHouseList();
	}

	@Override
	public List<HouseTypeBean> getTypeList(Integer depotId) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getTypeList(depotId);
	}
	
	//根据类型获取名称
	@Override
	public List<ShelfContentBean> getNameList(Integer depotTypeId) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getNameList(depotTypeId);
	}
	
	@Override
	public ContentBean getcontentGetList(String deviceName) {
		// TODO Auto-generated method stub
		Map<String, Object> map  = new HashMap<>();
		map.put("deviceName", deviceName);
		return deviceInputMapper.getcontentGetList(map);
	}
	
	//根据类型获取货架
	@Override
	public List<ContentBean> getShelfGetList(String deviceName) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getShelfGetList(deviceName);
	}

	@Override
	public List<StorageDeviceinput> queryByNumber(StorageDeviceinputExample example) {
		return deviceInputMapper.selectByExample(example);
	}

	//查询仓房对应的设备名称
	@Override
	public List<StorageDeviceinput> getDeviceInputList(Integer depotId) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getDeviceInputList(depotId);
	}

	//查询设备名称对应的型号
	@Override
	public List<StorageDeviceinput> getModelList(String deviceName) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getModelList(deviceName);
	}
	
	//查询型号对应的编号
	@Override
	public List<StorageDeviceinput> getNumberList(String deviceModel) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getNumberList(deviceModel);
	}

	//查询型号对应的数量
	@Override
	public List<StorageDeviceinput> getCountList(String number) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getCountList(number);
	}

	//报废
	@Override
	public void updateByPrimaryKeySelective(StorageDeviceinput storageDeviceinput) {
		// TODO Auto-generated method stub
		deviceInputMapper.updateByPrimaryKeySelective(storageDeviceinput);
	}

	@Override
	public List<StorageDeviceinput> getAllList(String number) {
		return deviceInputMapper.getAllList(number);
	}

	// 获取货架获取规格型号getModelGetList
	@Override
	public List<ContentBean> getModelGetList(Map<String, Object> map) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getModelGetList(map);
	}

	//获取规格型号对应的编号getNumberGetList
	@Override
	public List<StorageDeviceinput> getNumberGetList(String model) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getNumberGetList(model);
	}

	//根据编号获取可用数量
	@Override
	public List<StorageDeviceinput> getUseCountGetList(String number) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getUseCountGetList(number);
	}

	//获取编号和规格型号
	@Override
	public List<String> getDeviceModelList(Map<String,String> map) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getDeviceModelList(map);
	}

	@Override
	public List<String> deviceSbCodeModelList(String deviceName, String model) {
		return deviceInputMapper.deviceSbCodeModelList(deviceName,model);
	}

	//查询原有数量
	@Override
	public StorageDeviceinput selectById(Integer number) {
		// TODO Auto-generated method stub
		return deviceInputMapper.selectByPrimaryKey(number);
	}

	//获取保养名称
	@Override
	public List<String> getdevieName(String orgId) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getdevieName(orgId);
	}

	//获取维修名称
	@Override
	public List<String> getRepairNameList(String orgId) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getdevieName(orgId);
	}

	//领用时，根据规格型号和编号获取可用数量
	@Override
	public List<StorageDeviceinput> getUseCount(Map<String, Object> map) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getUseCount(map);
	}

	
	//获取设备数据
	@Override
	public List<StorageDeviceinput> queryDevice(HashMap<Object, Object> map) {
		// TODO Auto-generated method stub
		return deviceInputMapper.queryDevice(map);
	}

	//获取维修的规格型号和编号
	@Override
	public List<StorageDeviceinput> getDeviceModelRepair(String deviceName) {
		// TODO Auto-generated method stub
		return deviceInputMapper.getDeviceModelRepair(deviceName);
	}

	@Override
	public List<StorageDeviceinput> getDeviceModelListRepair(String deviceName) {
		// TODO Auto-generated method stub
		return null;
	}

	//获取每一类型入库的总数量
	@Override
	public List<Map<String, Object>> queryCountByType() {
		// TODO Auto-generated method stub
		return deviceInputMapper.queryCountByType();
	}

	@Override
	public List<StorageDeviceinput> queryDeviceAccount(StorageDeviceinputExample storageDeviceinputExample) {
		// TODO Auto-generated method stub
		return deviceInputMapper.queryDeviceAccount(storageDeviceinputExample);
	}

	@Override
	public int deviceBySbCode(String sbCdoe) {
		return Integer.valueOf(deviceInputMapper.deviceBySbCode(sbCdoe));
	}


}
